import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.*;
/**
 * Write a description of class ball here.
 * 
 * @author Justin Durbin
 * @version 2013_02_2013
 */
public class Ball extends Actor
{
    private int direction;
    private int deltaX; // change in x direction
    private int deltaY; // change in y direction
    private LeftCounter leftCounterPoints;
    private RightCounter rightCounterPoints;
    private int leftCounterPointsAdd;
    private int rightCounterPointsAdd;
    public Ball(LeftCounter leftcounter,RightCounter rightcounter)
    {
        leftCounterPoints = leftcounter;
        rightCounterPoints = rightcounter;
        leftCounterPointsAdd = 0;
        rightCounterPointsAdd = 0;
        do 
        {
            direction = Greenfoot.getRandomNumber(6);
        }
        while (direction == 3);
        deltaX = direction - 3;
        deltaY = direction - 3;

    }

    /**
     * Act - do whatever the ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {

        detectPaddle();
        ballMove();
        if (leftCounterPointsAdd == 10)
        {
            leftGameWon();
            Greenfoot.playSound("WINNER.wav");
            JOptionPane.showMessageDialog(null, "Player One Wins");

        }
        if (rightCounterPointsAdd == 10)
        {
            rightGameWon();
            Greenfoot.playSound("WINNER.wav");
            JOptionPane.showMessageDialog(null, "Player Two Wins");

        }
    }

    /**
     * move the ball
     */
    public void ballMove()
    {
        int xCoordinate = getX() + deltaX;
        int yCoordinate = getY() + deltaY;
        setLocation(xCoordinate, yCoordinate);
        int direction;
        if (atTopOrBottom())
        {
            deltaY = deltaY * (-1);

        }

        if (atSides() == true)
        {
            setLocation(300, 215);
            do 
            {
                direction = Greenfoot.getRandomNumber(6);
            }
            while (direction == 3);
            deltaX = direction - 3;
            deltaY = direction - 3;
        }
    }

    /**
     * test if the ball is at the top or the bottom
     */
    public boolean atTopOrBottom()
    {
        if (getY() < 63 || getY() > getWorld().getHeight() - 33)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    public void detectPaddle()
    {
        Actor rightPaddle = getOneIntersectingObject(Goalie1.class);
        Actor leftPaddle = getOneIntersectingObject(Goalie2.class);
        if (rightPaddle!= null)
        {
            deltaX = -deltaX;
            int offset = getY() - rightPaddle.getY();
            deltaY = deltaY + offset/10;
        }

        if (leftPaddle!= null)
        {
            deltaX = -deltaX;
            int offset = getY() - leftPaddle.getY();
            deltaY = deltaY + offset/10;
        }
    }

    public boolean atSides()
    {

        if (getX() < 50 ) 
        {           
            rightCounterPoints.add(1);
            rightCounterPointsAdd = rightCounterPointsAdd + 1;
            return true;
        }

        if(getX() > getWorld().getWidth() - 50)
        {
            leftCounterPoints.add(1);
            leftCounterPointsAdd = leftCounterPointsAdd + 1;

            return true;        
        }

        else
            return false;
    }

    public void rightGameWon()
    {
        Greenfoot.stop();
    }

    public void leftGameWon()
    {
        Greenfoot.stop();
    }
}

